# {{ ansible_managed }}
###################### Filebeat Configuration Example #########################

# This file is an example configuration file highlighting only the most common
# options. The filebeat.reference.yml file from the same directory contains all the
# supported options with more comments. You can use it as a reference.
#
# You can find the full configuration reference here:
# https://www.elastic.co/guide/en/beats/filebeat/index.html

# For more available modules and options, please see the filebeat.reference.yml sample
# configuration file.

#=========================== Filebeat inputs =============================
filebeat.inputs:
{% for source in filebeat_config_inputs -%}
{% set template = lookup('vars', 'filebeat_config_template_' + source.template) -%}
{% set filestream_id = source.override_id | default(template.id) -%}
{% set filestream_paths = source.override_paths | default(template.paths) %}
  - type: filestream
    id: {{filestream_id }}
    paths:
{% for path in filestream_paths %}
      - {{ path }}
{% endfor %}
    ignore_older: {{ template.ignore_older | default('30m') }}
    clean_inactive: {{ template.clean_inactive | default('45m') }}
    close_removed: {{ template.close_removed | default('true') }}
    clean_removed: {{ template.clean_removed | default('true') }}
{% if template.tags is defined %}
    tags: 
{% for tag in template.tags %}
      - {{ tag }}
{% endfor %}
{% if source.additional_tags is defined %}
{% for tag in source.additional_tags %}
      - {{ tag }}
{% endfor %}
{% endif %}
{% endif %}
{% if template.multiline is defined %}
    parsers:
      - multiline:
          type: {{ template.multiline.type }}
          pattern: {{ source.override_pattern | default(template.multiline.pattern)  }}
          negate: {{ template.multiline.negate | lower }}
          match: {{ template.multiline.match }}
{% endif %}
{% endfor %}
output:
  logstash:
    enables: true
    loadbalance: true
    worker: {{ filebeat_config_worker }}
    bulk_max_size: {{ filebeat_config_bulk_max_size }}
    ttl: {{ filebeat_config_ttl }}
    pipelining: {{ filebeat_config_pipelining }}
    ssl.certificate_authorities: ["{{ filebeat_ssl_directory }}/{{ filebeat_ca_filename | basename }}"]
    hosts:
{% for host in groups[filebeat_outputs_logstash_group] %}
      - {{ hostvars[host].ansible_host }}:5044
{% endfor %}

#============================= Filebeat modules ===============================

filebeat.config.modules:
  # Glob pattern for configuration loading
  path: ${path.config}/modules.d/*.yml

  # Set to true to enable config reloading
  reload.enabled: false

  # Period on which files under path should be checked for changes
  #reload.period: 10s

#==================== Elasticsearch template setting ==========================

#setup.template.settings:
  #index.number_of_shards: 1
  #index.codec: best_compression
  #_source.enabled: false

#================================ General =====================================

# The name of the shipper that publishes the network data. It can be used to group
# all the transactions sent by a single shipper in the web interface.
name: {{ ansible_hostname }}-filebeat

# The tags of the shipper are included in their own field with each
# transaction published.
#tags: ["service-X", "web-tier"]

# Optional fields that you can specify to add additional information to the
# output.
#fields:
#  env: staging

max_procs: {{ filebeat_config_max_procs }}

#============================== Dashboards =====================================
# These settings control loading the sample dashboards to the Kibana index. Loading
# the dashboards is disabled by default and can be enabled either by setting the
# options here or by using the `setup` command.
#setup.dashboards.enabled: false

# The URL from where to download the dashboards archive. By default this URL
# has a value which is computed based on the Beat name and version. For released
# versions, this URL points to the dashboard archive on the artifacts.elastic.co
# website.
#setup.dashboards.url:
#============================== Kibana =====================================

# Starting with Beats version 6.0.0, the dashboards are loaded via the Kibana API.
# This requires a Kibana endpoint configuration.
#setup.kibana:

  # Kibana Host
  # Scheme and port can be left out and will be set to the default (http and 5601)
  # In case you specify and additional path, the scheme is required: http://localhost:5601/path
  # IPv6 addresses should always be defined as: https://[2001:db8::1]:5601
  #host: ""
  #ssl.enabled: true
  #ssl.certificate_authorities: ["/etc/filebeat/config/certs/ca.crt"]
  #ssl.certificate: "/etc/filebeat/config/certs/client.crt"
  #ssl.key: "/etc/filebeat/config/certs/client.key"
  #ssl.verification_mode: none
#============================= Elastic Cloud ==================================
# These settings simplify using Filebeat with the Elastic Cloud (https://cloud.elastic.co/).

# The cloud.id setting overwrites the `output.elasticsearch.hosts` and
# `setup.kibana.host` options.
# You can find the `cloud.id` in the Elastic Cloud web UI.
#cloud.id:

# The cloud.auth setting overwrites the `output.elasticsearch.username` and
# `output.elasticsearch.password` settings. The format is `<user>:<pass>`.
#cloud.auth:

#================================ Outputs =====================================

# Configure what output to use when sending the data collected by the beat.

#-------------------------- Elasticsearch output ------------------------------
#output.elasticsearch:
  # Array of hosts to connect to.
  #hosts: ["localhost:9200"]

  # Optional protocol and basic auth credentials.
  #protocol: "https"
  #username: "elastic"
  #password: "changeme"

#================================ Processors =====================================

# Configure processors to enhance or manipulate events generated by the beat.

processors:
  - add_host_metadata: ~
  - add_cloud_metadata: ~

#================================ Logging =====================================

# Sets log level. The default log level is info.
# Available log levels are: error, warning, info, debug
#logging.level: debug

# At debug level, you can selectively enable logging only for some components.
# To enable all selectors use ["*"]. Examples of other selectors are "beat",
# "publish", "service".
#logging.selectors: ["*"]

logging.level: info
logging.to_files: true
logging.files:
  path: /var/log/filebeat
  name: filebeat
  keepfiles: 7
  permissions: 0640

#============================== Xpack Monitoring ===============================
# filebeat can export internal metrics to a central Elasticsearch monitoring
# cluster.  This requires xpack monitoring to be enabled in Elasticsearch.  The
# reporting is disabled by default.

# Set to true to enable the monitoring reporter.
#monitoring.enabled: false

# Sets the UUID of the Elasticsearch cluster under which monitoring data for this
# Filebeat instance will appear in the Stack Monitoring UI. If output.elasticsearch
# is enabled, the UUID is derived from the Elasticsearch cluster referenced by output.elasticsearch.
#monitoring.cluster_uuid:

# Uncomment to send the metrics to Elasticsearch. Most settings from the
# Elasticsearch output are accepted here as well.
# Note that the settings should point to your Elasticsearch *monitoring* cluster.
# Any setting that is not set is automatically inherited from the Elasticsearch
# output configuration, so if you have the Elasticsearch output configured such
# that it is pointing to your Elasticsearch monitoring cluster, you can simply
# uncomment the following line.
#monitoring.elasticsearch:

#================================= Migration ==================================

# This allows to enable 6.7 migration aliases
#migration.6_to_7.enabled: true
